//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//Copyright 1999 Dharma Shukla.

//Keep in mind that I wrote this code just for fun :-) 
//Use it at your own risk! 

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

#pragma once
#ifndef _WRITER_H_
#define _WRITER_H_

//Quick n' Dirty design & impl of PropertyBag Writer

class CWriter
{
public:
	CWriter():m_hFile(0){}

	HRESULT WriteControlCount(UINT n);
	HRESULT WriteHeader(REFCLSID rclsid);
	HRESULT WriteControlHeader(REFCLSID rclsid,LPCOLESTR pszPropName = 0,bool bIsSubObject = false);
	HRESULT WriteControlFooter(bool bIsSubObject = false);

	HRESULT CreateFile(LPCTSTR pszFileName,DWORD dwMode= OPEN_ALWAYS);
	HRESULT WriteFile(LPCTSTR psz);
	HRESULT CloseFile();
	HANDLE	GetFileHandle(){ return m_hFile; }	

private:
	HANDLE m_hFile;
};

#endif